package eu.ztsh.wymiana.service;

import eu.ztsh.wymiana.model.Rates;
import lombok.RequiredArgsConstructor;
import org.assertj.core.util.VisibleForTesting;
import org.springframework.stereotype.Service;

import java.time.Clock;
import java.time.DayOfWeek;
import java.time.LocalDate;
import java.time.temporal.TemporalAdjusters;

/**
 * NBP exchange rates service
 */
@Service
@RequiredArgsConstructor
public class NbpService {

    private final Clock clock;

    public double getSellRate(String currency) {
        throw new UnsupportedOperationException("Not implemented yet");
    }

    public double getBuyRate(String currency) {
        throw new UnsupportedOperationException("Not implemented yet");
    }

    /**
     * Calculates date for data fetch.
     * <p>
     * Usually this would be today, but as rates are set only Mon-Fri, during weekends it is needed to fetch last friday rates.
     *
     * @return date for data fetch
     */
    @VisibleForTesting
    LocalDate getFetchDate() {
        var today = LocalDate.now(clock);
        return isWeekend(today) ? today.with(TemporalAdjusters.previous(DayOfWeek.FRIDAY)) : today;
    }

    @VisibleForTesting
    Rates fetchData(String date) {
        throw new UnsupportedOperationException("Not implemented yet");
    }

    private static boolean isWeekend(LocalDate today) {
        return today.getDayOfWeek() == DayOfWeek.SATURDAY
            || today.getDayOfWeek() == DayOfWeek.SUNDAY;
    }
    private record RatesCache(LocalDate date, double buy, double sell) {

    }

}
